#ifndef PPU_H
#define PPU_H

enum { PPU_FPT_NORMAL=0, PPU_FPT_PT0, PPU_FPT_PT1, PPU_FPT_NT, PPU_FPT_CUSTOM };
#define PPU_FPT_ALL 8

typedef __fastcall u8(*fp_ppu_read_memorymap)(u16);
typedef __fastcall void(*fp_ppu_write_memorymap)(u16,u8);
typedef __fastcall void(*fp_ppu_modechangesignal)(int);

/* write only */						/* $2000 */
/* write only */						/* $2001 */
u8 __fastcall ppu_read_status(u16);				/* $2002 */
/* write only */						/* $2003 */
u8 __fastcall ppu_read_sprite_memory_data(u16);			/* $2004 */
/* write only */						/* $2005 */
/* write only */						/* $2006 */
u8 __fastcall ppu_read_memory_data(u16);			/* $2007 */
u8 __fastcall ppu_read_openbus(u16);				/* for write-onlies */

void __fastcall ppu_write_control1(u8);				/* $2000 */
void __fastcall ppu_write_control2(u8);				/* $2001 */
/* read only */							/* $2002 */
void __fastcall ppu_write_sprite_memory_address(u8);		/* $2003 */
void __fastcall ppu_write_sprite_memory_data(u8);		/* $2004 */
void __fastcall ppu_write_scroll(u8);				/* $2005 */
void __fastcall ppu_write_memory_address(u8);			/* $2006 */
void __fastcall ppu_write_memory_data(u8);			/* $2007 */

void ppu_set_fpt (int,int,fp_ppu_read_memorymap,fp_ppu_read_memorymap,fp_ppu_read_memorymap,fp_ppu_read_memorymap,fp_ppu_write_memorymap,fp_ppu_write_memorymap,fp_ppu_write_memorymap,fp_ppu_write_memorymap);
void ppu_set_modechangesignal(fp_ppu_modechangesignal);
void ppu_set_overscan(void);
void ppu_give_screen_ptr(u16*);
void ppu_init(void);
void ppu_clean(void);
void __fastcall ppu_new_frame(void);
void __fastcall ppu_clear_nmi_enable(void);
void ppu_set_update_nothing(void);
void __fastcall ppu_force_update(void);
int __fastcall ppu_get_vblank_nmi_disallowed(void);
int __fastcall ppu_get_skipped_cycle(void);
void __fastcall ppu_clear_status(void);

int* ppu_get_enabled_ptr(void);
int* ppu_get_valid_scanline_ptr(void);
u8* ppu_get_control1_ptr(void);
u8* ppu_get_control2_ptr(void);
int* ppu_get_reading_sprites_ptr(void);
int* ppu_get_rendering_ptr(void);
int* ppu_get_sc_ptr(void);
int* ppu_get_scc_ptr(void);
u16* ppu_get_address_ptr(void);
int* ppu_get_cycles_ptr(void);

#endif /* PPU_H */
